/***********************************************************************************************************************
* DISCLAIMER
* This software is supplied by Renesas Electronics Corporation and is only intended for use with Renesas products.
* No other uses are authorized. This software is owned by Renesas Electronics Corporation and is protected under all
* applicable laws, including copyright laws. 
* THIS SOFTWARE IS PROVIDED "AS IS" AND RENESAS MAKES NO WARRANTIESREGARDING THIS SOFTWARE, WHETHER EXPRESS, IMPLIED
* OR STATUTORY, INCLUDING BUT NOT LIMITED TO WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
* NON-INFRINGEMENT.  ALL SUCH WARRANTIES ARE EXPRESSLY DISCLAIMED.TO THE MAXIMUM EXTENT PERMITTED NOT PROHIBITED BY
* LAW, NEITHER RENESAS ELECTRONICS CORPORATION NOR ANY OF ITS AFFILIATED COMPANIES SHALL BE LIABLE FOR ANY DIRECT,
* INDIRECT, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES FOR ANY REASON RELATED TO THIS SOFTWARE, EVEN IF RENESAS OR
* ITS AFFILIATES HAVE BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.
* Renesas reserves the right, without notice, to make changes to this software and to discontinue the availability 
* of this software. By using this software, you agree to the additional terms and conditions found by accessing the 
* following link:
* http://www.renesas.com/disclaimer
*
* Copyright (C) 2012, 2015 Renesas Electronics Corporation. All rights reserved.
***********************************************************************************************************************/

/***********************************************************************************************************************
* File Name    : r_cg_userdefine.h
* Version      : CodeGenerator for RL78/L12 V2.03.02.01 [15 May 2015]
* Device(s)    : R5F10RLC
* Tool-Chain   : CCRL
* Description  : This file includes user definition.
* Creation Date: 2016/02/05
***********************************************************************************************************************/

#ifndef _USER_DEF_H
#define _USER_DEF_H

/***********************************************************************************************************************
User definitions
***********************************************************************************************************************/

/* Start user code for function. Do not edit comment generated here */
#define LCD_POSITION_HOUR_HIGH_ABCD_SYNBOL   (&SEG26)    /* Display start position(tens place of hour data) */
#define LCD_POSITION_HOUR_HIGH_EFG_SYNBOL    (&SEG27)    /* Display start position(tens place of hour data) */
#define LCD_POSITION_HOUR_LOW_ABCD_SYNBOL    (&SEG24)    /* Display start position(ones place of hour data) */
#define LCD_POSITION_HOUR_LOW_EFG_SYNBOL     (&SEG25)    /* Display start position(ones place of hour data) */
#define LCD_POSITION_COLON                   (&SEG23)    /* Display start position(colon) */
#define LCD_POSITION_MINUTE_HIGH_ABCD_SYNBOL (&SEG21)    /* Display start position(tens place of minute data) */
#define LCD_POSITION_MINUTE_HIGH_EFG_SYNBOL  (&SEG22)    /* Display start position(tens place of minute data) */
#define LCD_POSITION_MINUTE_LOW_ABCD_SYNBOL  (&SEG19)    /* Display start ppsition(ones place of minute data) */
#define LCD_POSITION_MINUTE_LOW_EFG_SYNBOL   (&SEG20)    /* Display start ppsition(ones place of minute data) */
#define LCD_DATA_0                           (0x0A0F)    /* LCD Data(0) */
#define LCD_DATA_1                           (0x0006)    /* LCD Data(1) */
#define LCD_DATA_2                           (0x060D)    /* LCD Data(2) */
#define LCD_DATA_3                           (0x040F)    /* LCD Data(3) */
#define LCD_DATA_4                           (0x0C06)    /* LCD Data(4) */
#define LCD_DATA_5                           (0x0C0B)    /* LCD Data(5) */
#define LCD_DATA_6                           (0x0E0B)    /* LCD Data(6) */
#define LCD_DATA_7                           (0x080E)    /* LCD Data(7) */
#define LCD_DATA_8                           (0x0E0F)    /* LCD Data(8) */
#define LCD_DATA_9                           (0x0C0F)    /* LCD Data(9) */
#define LCD_DATA_COLON                       (0x02)      /* LCD Data(colon) */
#define LCD_DATA_NONE                        (0x0000)    /* LCD Data(none) */
#define INTERRUPT_OFF                        (0x00)      /* Interruption factor parameter(none) */
#define INTRC_ON                             (0x01)      /* Interruption factor parameter(INTRTC) */
#define INTPN_ON                             (0x02)      /* Interruption factor parameter(INTP) */
#define LCD_NUM_DATA_SIZE                    (0x02)      /* Size of LCD data */
#define LCD_COLON_DATA_SIZE                  (0x01)      /* Size of colon data */
#define LCD_NUM_DATA_FONT_COUNT              (0x0C)      /* Number of LCD data */
#define LCD_DATA_NONE_INDEX                  (0x0A)      /* Index of none-data */
#define LCD_DATA_COLON_INDEX                 (0x0B)      /* Index of colon data */
#define WATCH_DISPLAY                        (0x00)      /* Display status(time display) */
#define HOUR_ADJUST                          (0x01)      /* Display status(hour adjust) */
#define MINUTE_ADJUST                        (0x02)      /* Display status(minite adjust) */
#define SET_SWITCH_ON                        (0x01)      /* Switch status(SET) */
#define DOWN_SWITCH_ON                       (0x02)      /* Switch status(DOWN) */
#define UP_SWITCH_ON                         (0x03)      /* Switch status(UP) */
#define SWITCH_ALL_OFF                       (0x00)      /* Switch status(NONE) */
#define LCD_DISPLAY_NORMAL                   (0x00)      /* LCD display status(normal) */
#define LCD_DISPLAY_BLINK                    (0x01)      /* LCD display status(blink) */

/***********************************************************************************************************************
Exported global functions (to be accessed by other files)
***********************************************************************************************************************/
uint8_t r_main_get_interrupt(void);
void r_main_analyze_switch(void);
uint8_t r_main_get_switch_status(void);
void r_main_command_analyze(uint8_t t_switch);
void r_main_set_switch_process(void);
void r_main_up_switch_process(void);
void r_main_down_switch_process(void);
void r_main_lcd_display_time(void);
void r_main_lcd_hour_blink(void);
void r_main_lcd_minute_blink(void);
void r_main_lcd_display_normal(void);
void r_main_seg_data_set(volatile uint8_t *seg_register, uint8_t *seg_data);
uint8_t r_main_bcd_inc(uint8_t bcd_data);
uint8_t r_main_bcd_dec(uint8_t bcd_data);


/* End user code. Do not edit comment generated here */
#endif
