/***********************************************************************************************************************
* DISCLAIMER
* This software is supplied by Renesas Electronics Corporation and is only intended for use with Renesas products.
* No other uses are authorized. This software is owned by Renesas Electronics Corporation and is protected under all
* applicable laws, including copyright laws. 
* THIS SOFTWARE IS PROVIDED "AS IS" AND RENESAS MAKES NO WARRANTIESREGARDING THIS SOFTWARE, WHETHER EXPRESS, IMPLIED
* OR STATUTORY, INCLUDING BUT NOT LIMITED TO WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
* NON-INFRINGEMENT.  ALL SUCH WARRANTIES ARE EXPRESSLY DISCLAIMED.TO THE MAXIMUM EXTENT PERMITTED NOT PROHIBITED BY
* LAW, NEITHER RENESAS ELECTRONICS CORPORATION NOR ANY OF ITS AFFILIATED COMPANIES SHALL BE LIABLE FOR ANY DIRECT,
* INDIRECT, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES FOR ANY REASON RELATED TO THIS SOFTWARE, EVEN IF RENESAS OR
* ITS AFFILIATES HAVE BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.
* Renesas reserves the right, without notice, to make changes to this software and to discontinue the availability 
* of this software. By using this software, you agree to the additional terms and conditions found by accessing the 
* following link:
* http://www.renesas.com/disclaimer
*
* Copyright (C) 2012, 2015 Renesas Electronics Corporation. All rights reserved.
***********************************************************************************************************************/

/***********************************************************************************************************************
* File Name    : r_main.c
* Version      : CodeGenerator for RL78/L12 V2.03.02.01 [15 May 2015]
* Device(s)    : R5F10RLC
* Tool-Chain   : CCRL
* Description  : This file implements main function.
* Creation Date: 2016/02/05
***********************************************************************************************************************/

/***********************************************************************************************************************
Includes
***********************************************************************************************************************/
#include "r_cg_macrodriver.h"
#include "r_cg_cgc.h"
#include "r_cg_port.h"
#include "r_cg_intc.h"
#include "r_cg_rtc.h"
#include "r_cg_it.h"
#include "r_cg_lcd.h"
/* Start user code for include. Do not edit comment generated here */
#include "string.h"
/* End user code. Do not edit comment generated here */
#include "r_cg_userdefine.h"

/***********************************************************************************************************************
Pragma directive
***********************************************************************************************************************/
/* Start user code for pragma. Do not edit comment generated here */
/* End user code. Do not edit comment generated here */

/***********************************************************************************************************************
Global variables and functions
***********************************************************************************************************************/
/* Start user code for global. Do not edit comment generated here */

static uint16_t g_font_data[LCD_NUM_DATA_FONT_COUNT] = { LCD_DATA_0, LCD_DATA_1, LCD_DATA_2, LCD_DATA_3, LCD_DATA_4,
                                                        LCD_DATA_5, LCD_DATA_6, LCD_DATA_7, LCD_DATA_8, LCD_DATA_9,
                                                        LCD_DATA_NONE, LCD_DATA_COLON };
static uint8_t g_watch_status =0U;
static uint8_t g_hour =0U;
static uint8_t g_minute =0U;
static uint8_t g_lcd_blink =0U;
static uint8_t g_intp_count =0U;

/* End user code. Do not edit comment generated here */
void R_MAIN_UserInit(void);

/***********************************************************************************************************************
* Function Name: main
* Description  : This function implements main function.
* Arguments    : None
* Return Value : None
***********************************************************************************************************************/
void main(void)
{
    R_MAIN_UserInit();
    /* Start user code. Do not edit comment generated here */
    {
        rtc_counter_value_t time_data;
        uint8_t interrupt_param =0U;

        while (1U)
        {
            STOP();                                        /* STOP mode */
            interrupt_param = r_main_get_interrupt();      /* Get interruption factor */

            switch (interrupt_param)
            {
                /* ---- Get time data ---- */
                case INTRC_ON:
                    R_RTC_Get_CounterValue(&time_data);
                    g_hour = time_data.hour;
                    g_minute = time_data.min;
                    /* ---- Time displays on LCD ---- */
                    r_main_lcd_display_time();
                    break;

                /* ---- Switch number specification ---- */
                case INTPN_ON:
                    while (g_intp_count < 3U)
                    {
                        while ((P13_bit.no7 == 1U) && (P3_bit.no2 == 1U) && (P3_bit.no1 == 1U))
                        {
                            NOP();
                        }
                        r_main_analyze_switch();
                        /* ---- Time displays on LCD ---- */
                        r_main_lcd_display_time();    
                    }
                    g_intp_count = 0U;
                    PIF0 = 0U;
                    PMK0 = 0U;
                    break;

                default:
                    break;
            }
        }
    }
    /* End user code. Do not edit comment generated here */
}

/***********************************************************************************************************************
* Function Name: R_MAIN_UserInit
* Description  : This function adds user code before implementing main function.
* Arguments    : None
* Return Value : None
***********************************************************************************************************************/
void R_MAIN_UserInit(void)
{
    /* Start user code. Do not edit comment generated here */
/* This code is generated by CubeSuite+ automatically, but is not appropriate for this application;
   so please invalidate it */
#if 0
    EI();
#endif

    R_LCD_Set_VoltageOn();
    R_LCD_Start();

    /* ---- Initialize display ---- */
    SEG19 = 0x00;
    SEG20 = 0x00;
    SEG21 = 0x00;
    SEG22 = 0x00;
    SEG23 = 0x00;
    SEG24 = 0x00;
    SEG26 = 0x00;
    SEG27 = 0x00;

    g_watch_status = WATCH_DISPLAY;                     /* Set clock display state */
    g_hour = 0x00U;                                     /* Initialize hour data */
    g_minute = 0x00U;                                   /* Initialize minute data */
    g_lcd_blink = LCD_DISPLAY_NORMAL;                   /* Initialize LCD display state */

    R_INTC0_Start();                                    /* Start INTP0 */
    R_RTC_Set_ConstPeriodInterruptOn(ONEMIN);           /* RTC interrupt enable */
    r_rtc_operation_start();                            /* RTC start */
    RTCIF = 1U;                                         /* Set RTCIF */
    /* End user code. Do not edit comment generated here */
}

/* Start user code for adding. Do not edit comment generated here */
/***********************************************************************************************************************
* Function Name: r_main_get_interrupt
* Description  : This function get interruption factor.
* Arguments    : None
* Return Value : result -
*                    Interruption factor
***********************************************************************************************************************/
uint8_t r_main_get_interrupt(void)
{
    uint8_t result = 0U;

    /* ==== INTP interrupt ==== */
    if (PIF0 == 0U)
    {
        /* ---- RTC interrupt ---- */
        if (RTCIF == 0U)
        {
            /* Do Nothing */
        }
        else
        {
            result = INTRC_ON;                         /* Set INTP interrupt generating */
            RTCIF = 0U;
        }
    }
    else
    {
        result = INTPN_ON;                             /* Set RTC interrupt generating */
        PIF0 = 0U;
    }

    return (result);
}

/***********************************************************************************************************************
* Function Name: r_main_analyze_switch
* Description  : This function switch number specification.
* Arguments    : None
* Return Value : None
***********************************************************************************************************************/
void r_main_analyze_switch(void)
{
    uint8_t switch_status =0U;

    r_it_operation_start();                            /* Start interval timer */

    /* ---- Wait for ITIF = 1 ---- */
    while (ITIF != 1U)
    {
        /* Do Nothing */
    }

    r_it_operation_stop();                             /* Stop interval timer */

    switch_status = r_main_get_switch_status();         /* Get switch status */

    if (switch_status != SWITCH_ALL_OFF)
    {
        r_main_command_analyze(switch_status);          /* Switch number specification */
    }
    else
    {
        /* Do Nothing */
    }
}

/***********************************************************************************************************************
* Function Name: r_main_get_switch_status
* Description  : This function get switch status.
* Arguments    : None
* Return Value : switch_status -
                     The kind of pushed switch
***********************************************************************************************************************/
uint8_t r_main_get_switch_status(void)
{
    uint8_t switch_status = SWITCH_ALL_OFF;

    /* ---- Set switch status ---- */
    if ((P13_bit.no7 == 0U) && (P3_bit.no2 == 1U) && (P3_bit.no1 == 1U))
    {
        switch_status = SET_SWITCH_ON;
        g_intp_count ++;
    }
    else if ((P3_bit.no2 == 0U) && (P13_bit.no7 == 1U) && (P3_bit.no1 == 1U))
    {
        switch_status = UP_SWITCH_ON;
    }
    else if ((P3_bit.no1 == 0U) && (P13_bit.no7 == 1U) && (P3_bit.no2 == 1U))
    {
        switch_status = DOWN_SWITCH_ON;
    }
    else
    {
        /* Do Nothing */
    }
    
    while ((P13_bit.no7 != 1U) || (P3_bit.no2 != 1U) || (P3_bit.no1 != 1U))
    {
        NOP();
    }

    return (switch_status);
}

/***********************************************************************************************************************
* Function Name: r_main_command_analyze
* Description  : This function processing is branched according to the kind of pushed switch.
* Arguments    : t_switch -
*                    Kind of pushed switch
* Return Value : None
***********************************************************************************************************************/
void r_main_command_analyze(uint8_t t_switch)
{
    switch (t_switch)
    {
        case SET_SWITCH_ON:
            r_main_set_switch_process();
            break;

        case UP_SWITCH_ON:
            r_main_up_switch_process();
            break;

        case DOWN_SWITCH_ON:
            r_main_down_switch_process();
            break;

        default:
            break;
    }
}

/***********************************************************************************************************************
* Function Name: r_main_set_switch_process
* Description  : This function processing when a set switch is pushed.
* Arguments    : None
* Return Value : None
***********************************************************************************************************************/
void r_main_set_switch_process(void)
{
    rtc_counter_value_t time_data;

    switch (g_watch_status)
    {
        case WATCH_DISPLAY:
            g_watch_status = HOUR_ADJUST;               /* Set hour adjust state */
            g_lcd_blink = LCD_DISPLAY_BLINK;            /* Set blink display state */
            R_RTC_Set_ConstPeriodInterruptOn(HALFSEC); /* RTC interrupt enable */
            BLON = 1U;                                  /* Set LCD blink */
            break;

        case HOUR_ADJUST:
            g_watch_status = MINUTE_ADJUST;             /* Set minute adjust state */
            break;

        case MINUTE_ADJUST:
            g_lcd_blink = LCD_DISPLAY_NORMAL;           /* Set clock display state */
            R_RTC_Set_ConstPeriodInterruptOn(ONEMIN);  /* RTC interrupt enable */
            BLON = 0U;                                  /* Set LCD not blink */

            /* ---- Set time data ---- */
            time_data.hour = g_hour;
            time_data.min = g_minute;
            time_data.sec = 0x00U;
            R_RTC_Set_CounterValue(time_data);

            g_watch_status = WATCH_DISPLAY;             /* Set time display state */
            break;

        default:
            break;
    }
}

/***********************************************************************************************************************
* Function Name: r_main_up_switch_process
* Description  : This function processing when a up switch is pushed.
* Arguments    : None
* Return Value : None
***********************************************************************************************************************/
void r_main_up_switch_process(void)
{
    switch (g_watch_status)
    {
        case HOUR_ADJUST:
            g_hour = r_main_bcd_inc(g_hour);
    
            /* ---- When hour data is 0x24 ---- */
            if (g_hour == 0x24U)
            {
                g_hour = 0x00U;                         /* Hour data is set as 0x00 */
            }
            else
            {
                /* Do Nothing */
            }
            break;

        case MINUTE_ADJUST:
            g_minute = r_main_bcd_inc(g_minute);           /* Increment minute data */


            /* ---- When minute data is 0x60 ---- */
            if (g_minute == 0x60U)
            {
                g_minute = 0x00U;                       /* Minute data is set as 0x00 */
            }
            else
            {
                /* Do Nothing */
            }
            break;

        default:
            break;
    }

    /* ---- Set time data ---- */
    r_rtc_set_counter_value_hour_min(g_hour, g_minute);
}

/***********************************************************************************************************************
* Function Name: r_main_down_switch_process
* Description  : This function processing when a down switch is pushed.
* Arguments    : None
* Return Value : None
***********************************************************************************************************************/
void r_main_down_switch_process(void)
{
    switch (g_watch_status)
    {
        case HOUR_ADJUST:
            g_hour = r_main_bcd_dec(g_hour);            /* Decrement hour data */

            /* ---- When hour data is 0x99 ---- */
            if (g_hour == 0x99)
            {
                g_hour = 0x23;                         /* Hour data is set as 0x23 */
            }
            else
            {
                /* Do Nothing */
            }
            break;

        case MINUTE_ADJUST:
            g_minute = r_main_bcd_dec(g_minute);         /* Decrement minute data */

            /* ---- When minute data is 0x99 ---- */
            if (g_minute == 0x99)
            {
                g_minute = 0x59;                       /* Minute data is set as 0x59 */
            }
            else
            {
                /* Do Nothing */
            }
            break;

        default:
            break;
    }

    /* ---- Set time data ---- */
    r_rtc_set_counter_value_hour_min(g_hour, g_minute);
}

/***********************************************************************************************************************
* Function Name: r_main_lcd_display_time
* Description  : This function time displays on LCD.
* Arguments    : None
* Return Value : None
***********************************************************************************************************************/
void r_main_lcd_display_time(void)
{
    if (g_lcd_blink == LCD_DISPLAY_BLINK)
    {
        if (g_watch_status == HOUR_ADJUST)
        {
            r_main_lcd_hour_blink();
        }
        else if (g_watch_status == MINUTE_ADJUST)
        {
            r_main_lcd_minute_blink();
        }
        else
        {
            /* Do Nothing */
        }
    }
    else
    {
        r_main_lcd_display_normal();
    }
}

/***********************************************************************************************************************
* Function Name: r_main_lcd_hour_blink
* Description  : This function hour blink data setup.
* Arguments    : None
* Return Value : None
***********************************************************************************************************************/
void r_main_lcd_hour_blink(void)
{
    uint16_t disp_data;
    uint8_t num_work =0U;

	num_work = (g_hour >> 4U);                             /* Get tens place of hour data */

    /* When time is less than 10 */
    if (num_work == 0U)
    {
        num_work = LCD_DATA_NONE_INDEX;                 /* Set none data */
    }
    else
    {
        /* Do Nothing */
    }

    /* ==== Clear B domain, in order to blink hour data ==== */
    /* ---- Display tens place of hour data ---- */
    r_main_seg_data_set(LCD_POSITION_HOUR_HIGH_ABCD_SYNBOL, ((uint8_t*)&g_font_data[num_work]));
    r_main_seg_data_set(LCD_POSITION_HOUR_HIGH_EFG_SYNBOL, (((uint8_t*)&g_font_data[num_work])+1));

    /* ---- Display ones place of hour data ---- */
	num_work = (g_hour & 0x0FU);                           /* Get ones place of hour data */
    r_main_seg_data_set(LCD_POSITION_HOUR_LOW_ABCD_SYNBOL, ((uint8_t*)&g_font_data[num_work]));
    r_main_seg_data_set(LCD_POSITION_HOUR_LOW_EFG_SYNBOL, (((uint8_t*)&g_font_data[num_work])+1));

    /* ==== The data of A domain is copied to B domain, in order to not blink minute data ==== */
    /* ---- Display colon ---- */
    num_work = LCD_DATA_COLON_INDEX;
	disp_data = (g_font_data[num_work] * 0x11U);
    r_main_seg_data_set(LCD_POSITION_COLON, ((uint8_t*)&disp_data));

    /* ---- Display tens place of minute data ---- */
	num_work = (g_minute >> 4U);                           /* Get tens place of minute data */
	disp_data = (g_font_data[num_work] * 0x11U);            
    r_main_seg_data_set(LCD_POSITION_MINUTE_HIGH_ABCD_SYNBOL, ((uint8_t*)&disp_data));
    r_main_seg_data_set(LCD_POSITION_MINUTE_HIGH_EFG_SYNBOL, (((uint8_t*)&disp_data)+1));

    /* ---- Display ones place of minute data ---- */
	num_work = (g_minute & 0x0FU);                         /* Get ones place of minute data */
	disp_data = (g_font_data[num_work] * 0x11U); 
    r_main_seg_data_set(LCD_POSITION_MINUTE_LOW_ABCD_SYNBOL, ((uint8_t*)&disp_data));
    r_main_seg_data_set(LCD_POSITION_MINUTE_LOW_EFG_SYNBOL, (((uint8_t*)&disp_data)+1));
}

/***********************************************************************************************************************
* Function Name: r_main_lcd_minute_blink
* Description  : This function minute blink data setup.
* Arguments    : None
* Return Value : None
***********************************************************************************************************************/
void r_main_lcd_minute_blink(void)
{
    uint16_t disp_data =0U;
    uint8_t num_work =0U;

	num_work = (g_hour >> 4U);                             /* Get tens place of hour data */

    /* When time is less than 10 */
    if (num_work == 0U)
    {
        num_work = LCD_DATA_NONE_INDEX;                 /* Set none data */
    }
    else
    {
        /* Do Nothing */
    }

    /* ==== The data of A domain is copied to B domain, in order to not blink hour data ==== */
    /* ---- Display tens place of hour data ---- */
	disp_data = (g_font_data[num_work] * 0x11U);
    r_main_seg_data_set(LCD_POSITION_HOUR_HIGH_ABCD_SYNBOL, ((uint8_t*)&disp_data));
    r_main_seg_data_set(LCD_POSITION_HOUR_HIGH_EFG_SYNBOL, (((uint8_t*)&disp_data)+1));

    /* ---- Display ones place of hour data ---- */
	num_work = (g_hour & 0x0FU);                           /* Get ones place of hour data */
	disp_data = (g_font_data[num_work] * 0x11U);
    r_main_seg_data_set(LCD_POSITION_HOUR_LOW_ABCD_SYNBOL, ((uint8_t*)&disp_data));
    r_main_seg_data_set(LCD_POSITION_HOUR_LOW_EFG_SYNBOL, (((uint8_t*)&disp_data)+1));

    /* ---- Display colon ---- */
    num_work = LCD_DATA_COLON_INDEX;
	disp_data = (g_font_data[num_work] * 0x11U);
    r_main_seg_data_set(LCD_POSITION_COLON, ((uint8_t*)&disp_data));

    /* ==== Clear B domain, in order to blink minute data ==== */
    /* ---- Display tens place of minute data ---- */
	num_work = (g_minute >> 4U);                           /* Get tens place of minute data */
    r_main_seg_data_set(LCD_POSITION_MINUTE_HIGH_ABCD_SYNBOL, ((uint8_t*)&g_font_data[num_work]));
    r_main_seg_data_set(LCD_POSITION_MINUTE_HIGH_EFG_SYNBOL, (((uint8_t*)&g_font_data[num_work])+1));

    /* ---- Display ones place of minute data ---- */
	num_work = (g_minute & 0x0FU);                         /* Get ones place of minute data */
    r_main_seg_data_set(LCD_POSITION_MINUTE_LOW_ABCD_SYNBOL, ((uint8_t*)&g_font_data[num_work]));
    r_main_seg_data_set(LCD_POSITION_MINUTE_LOW_EFG_SYNBOL, (((uint8_t*)&g_font_data[num_work])+1));
}

/***********************************************************************************************************************
* Function Name: r_main_lcd_display_normal
* Description  : This function minute blink data setup.
* Arguments    : None
* Return Value : None
***********************************************************************************************************************/
void r_main_lcd_display_normal(void)
{
    uint8_t num_work =0U;

	num_work = (g_hour >> 4U);                             /* Get tens place of hour data */

    /* When time is less than 10 */
    if (num_work == 0U)
    {
        num_work = LCD_DATA_NONE_INDEX;                 /* Set none data */
    }
    else
    {
        /* Do Nothing */
    }

    /* ---- Display tens place of hour data ---- */
    r_main_seg_data_set(LCD_POSITION_HOUR_HIGH_ABCD_SYNBOL, ((uint8_t*)&g_font_data[num_work]));
    r_main_seg_data_set(LCD_POSITION_HOUR_HIGH_EFG_SYNBOL, (((uint8_t*)&g_font_data[num_work])+1U));

    /* ---- Display ones place of hour data ---- */
	num_work = (g_hour & 0x0FU);                           /* Get ones place of hour data */
    r_main_seg_data_set(LCD_POSITION_HOUR_LOW_ABCD_SYNBOL, ((uint8_t*)&g_font_data[num_work]));
    r_main_seg_data_set(LCD_POSITION_HOUR_LOW_EFG_SYNBOL, (((uint8_t*)&g_font_data[num_work])+1));

    /* ---- Display colon ---- */
    num_work = LCD_DATA_COLON_INDEX;
    r_main_seg_data_set(LCD_POSITION_COLON, ((uint8_t*)&g_font_data[num_work]));

    /* ---- Display tens place of minute data ---- */
	num_work = (g_minute >> 4U);                           /* Get tens place of minute data */
    r_main_seg_data_set(LCD_POSITION_MINUTE_HIGH_ABCD_SYNBOL, ((uint8_t*)&g_font_data[num_work]));
    r_main_seg_data_set(LCD_POSITION_MINUTE_HIGH_EFG_SYNBOL, (((uint8_t*)&g_font_data[num_work])+1));

    /* ---- Display ones place of minute data ---- */
	num_work = (g_minute & 0x0FU);                         /* Get ones place of minute data */
    r_main_seg_data_set(LCD_POSITION_MINUTE_LOW_ABCD_SYNBOL, ((uint8_t*)&g_font_data[num_work]));
    r_main_seg_data_set(LCD_POSITION_MINUTE_LOW_EFG_SYNBOL, (((uint8_t*)&g_font_data[num_work])+1));
}

/***********************************************************************************************************************
* Function Name: r_main_seg_data_set
* Description  : The stores display data to the LCD display data memory.
* Arguments    : None
* Return Value : None
***********************************************************************************************************************/
void r_main_seg_data_set(volatile uint8_t *seg_register, uint8_t *seg_data)
{
	(*seg_register) = (*seg_data);
}

/***********************************************************************************************************************
* Function Name: r_main_bcd_inc
* Description  : Increment the BCD data.
* Arguments    : None
* Return Value : None
***********************************************************************************************************************/
uint8_t r_main_bcd_inc(uint8_t bcd_data)
{
    uint8_t digit_10 = (bcd_data>>4);
    uint8_t digit_1 = (bcd_data & 0xf);

	digit_1 = (digit_1 +1U);
    if(digit_1>9)
    {
        ++digit_10;
        digit_1 -= 10U;
    }
    else
    {
        /* Do Nothing */
    }
	digit_10 = (digit_10<<4U); 
    return(digit_1 + digit_10) ;
}

/***********************************************************************************************************************
* Function Name: r_main_bcd_dec
* Description  : Decrement the BCD data.
* Arguments    : None
* Return Value : None
***********************************************************************************************************************/
uint8_t r_main_bcd_dec(uint8_t bcd_data)
{
    uint8_t digit_10 = (bcd_data>>4);
    uint8_t digit_1 = (bcd_data & 0xFU);
    
    if (digit_1 == 0U)
    {
        if (digit_10 == 0U)
        {
            digit_10 = 0x09U;
            digit_1 = 0x09U;
        }
        else
        {
            --digit_10;
            digit_1 = 9U;
        }
    }
    else
    {
    	digit_1 = (digit_1 - 1U);
    }
    
	digit_10 = (digit_10<<4U); 
    return (digit_10+ digit_1);
}

/* End user code. Do not edit comment generated here */
